//+------------------------------------------------------------------+
//|                    Initial file   i_Trend.mq4                    |
//|                 Copyright  2004-2013, MetaQuotes Software Corp. |
//|                                                                  |
//|      Mod by Robert B. - Add TextToSpeech Function                |
//|       & rename it i_Trend_TTS_v1.1.mq4                           |
//|                                                                  |
//| Original i_Trend.mq4 Mod by Master4x, Add Sound Alert Function   |
//|                                                                  |
//|           gSpeak.mqh & speak.dll coded by Codersguru             |
//|                                                                  |
//|                        ENJOY !                                   |
//+------------------------------------------------------------------+

#property copyright "Copyright  2004-2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LightSeaGreen
#property indicator_color2 Crimson

#include <gSpeak.mqh>      // NOTE  ...  Reference to gSpeak.mqh which must be installed in the "include" directory.
                           // NOTE  ...  The operating system module, speak.dll, must also be installed in the "library" directory.
                           // NOTE  ...  These two modules access the currently selected text-to-speech engine of your computer. 
                           // NOTE  ...  Of course text-to-speech engine and appropriate voices must be installed on your computer. 



//---- define strings for TTS function

string CurrentPair;
string CurrentPeriod;

//---- input parameters

extern int Bands_Mode_0_2=0;  // =0-2 MODE_MAIN, MODE_LOW, MODE_HIGH
extern int Power_Price_0_6=0; // =0-6 PRICE_CLOSE,PRICE_OPEN,PRICE_HIGH,PRICE_LOW,PRICE_MEDIAN,PRICE_TYPICAL,PRICE_WEIGHTED
extern int Price_Type_0_3=0;  // =0-3 PRICE_CLOSE,PRICE_OPEN,PRICE_HIGH,PRICE_LOW
extern int Bands_Period=13;
extern int Bands_Deviation=2;
extern int Power_Period=13;
extern int CountBars=300;

extern bool PopUp_Alerts = true;
extern bool Text_To_Speech_Alerts = true;
extern bool Email_Alerts = false;
extern bool Mobile_Push_Alerts = false;


datetime alert_time;

//---- buffers

double value[];
double value2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//   string short_name;
//---- indicator line
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(0,value);
   SetIndexBuffer(1,value2);
   
   Comments();

   return(0);
  }
//+------------------------------------------------------------------+
//| Trend                                                         |
//+------------------------------------------------------------------+
int start()
  {
 
   SetIndexDrawBegin(0,Bars-CountBars+Bands_Period+1);
   SetIndexDrawBegin(1,Bars-CountBars+Bands_Period+1);
   int i,CurrentBar,Bands_Mode,counted_bars=IndicatorCounted();
   double Power_Price,CurrentPrice;
//----
   if(Bars<=Bands_Period) return(0);
   
//---- initial zero

   if(counted_bars<Bands_Period)
   {
      for(i=1;i<=Bands_Period;i++) value[Bars-i]=0.0;
      for(i=1;i<=Bands_Period;i++) value2[Bars-i]=0.0;
   }
//----
   i=CountBars-Bands_Period-1;
//   if(counted_bars>=Bands_Period) i=Bars-counted_bars-1;

     
if (Bands_Mode_0_2==1) Bands_Mode=MODE_LOW;
if (Bands_Mode_0_2==2) Bands_Mode=MODE_HIGH;
if (Bands_Mode_0_2==0) Bands_Mode=MODE_MAIN;

if (Power_Price_0_6==1) Power_Price=PRICE_OPEN;
if (Power_Price_0_6==2) Power_Price=PRICE_HIGH;
if (Power_Price_0_6==3) Power_Price=PRICE_LOW;
if (Power_Price_0_6==4) Power_Price=PRICE_MEDIAN;
if (Power_Price_0_6==5) Power_Price=PRICE_TYPICAL;
if (Power_Price_0_6==6) Power_Price=PRICE_WEIGHTED;
if (Power_Price_0_6==0) Power_Price=PRICE_CLOSE;

for (i=CountBars-1; i>=0; i--)
{  
  if (Price_Type_0_3==1) CurrentPrice=Open[i];
  
  if (Price_Type_0_3==2) CurrentPrice=High[i];

  if (Price_Type_0_3==3) CurrentPrice=Low[i];
  if (Price_Type_0_3==0) CurrentPrice=Close[i]; 
     
  value[i]=CurrentPrice-iBands(NULL,0,Bands_Period,Bands_Deviation,0,Bands_Mode,Power_Price,i);
  value2[i]=-(iBearsPower(NULL,0,Power_Period,Power_Price,i)+iBullsPower(NULL,0,Power_Period,Power_Price,i)); 

}  
 
// ---- Provides phonetic pronunciation for the Symbol().

// ---- NOTE ...  Additional pairs can be added here, with appropriate text (phonetic) according to your TTS engine.

      if (Symbol() == "EURUSD") CurrentPair = "euro dollar";         // or EURO
      if (Symbol() == "USDJPY") CurrentPair = "dollar yen";          // or YEN
      if (Symbol() == "GBPUSD") CurrentPair = "pound dollar";        // or CABLE
      if (Symbol() == "USDCHF") CurrentPair = "dollar swissy";       // or SWISSY
      if (Symbol() == "AUDUSD") CurrentPair = "aussie dollar ";      // or AUSSIE 
      if (Symbol() == "USDCAD") CurrentPair = "dollar loonie";       // or LOONIE
      if (Symbol() == "NZDUSD") CurrentPair = "kiwi dollar";         // or KIWI
      if (Symbol() == "EURGBP") CurrentPair = "euro pound";
      if (Symbol() == "EURJPY") CurrentPair = "euro yen";
      if (Symbol() == "EURCHF") CurrentPair = "euro swissy";
      if (Symbol() == "CHFJPY") CurrentPair = "swissy yen";
      if (Symbol() == "AUDJPY") CurrentPair = "aussie yen";
      if (Symbol() == "GBPCHF") CurrentPair = "pound swissy";
      if (Symbol() == "AUDCAD") CurrentPair = "aussie loonie";
      if (Symbol() == "GBPJPY") CurrentPair = "pound yen";
      if (Symbol() == "NZDJPY") CurrentPair = "kiwi yen";
      if (Symbol() == "EURCAD") CurrentPair = "euro loonie";
      if (Symbol() == "EURAUD") CurrentPair = "euro aussie";
      if (Symbol() == "AUDNZD") CurrentPair = "aussie kiwi";
 
 // ---- Exotics Pairs
      
      if (Symbol() == "USDZAR") CurrentPair = "dollar rand";
      if (Symbol() == "USDTHB") CurrentPair = "dollar baht";
      if (Symbol() == "USDMXN") CurrentPair = "dollar peso";
      if (Symbol() == "USDDKK") CurrentPair = "dollar krone";
      
//+-----------------------------------------------------------------+
 
// ---- Provides phonetic pronunciation for the Period().

// ---- NOTE ...  Additional period can be added here, with appropriate text (phonetic) according to your TTS engine.

      
      if (Period() == 5 )   CurrentPeriod = "priode M  5";
      if (Period() == 15)   CurrentPeriod = "priode M 15";
      if (Period() == 30)   CurrentPeriod = "priode M 30";
      if (Period() == 60)   CurrentPeriod = "priode H  1";
      if (Period() == 240)  CurrentPeriod = "priode H  4";
      if (Period() == 1440) CurrentPeriod = "priode D  1";

//+------------------------------------------------------------------+
  
   Alerts();

   return(0);
  }
  


//---- Add TextToSpeech Alert in this section. 

//---- Note : Display window alert & Play wav alert if PopUp_Alerts is "true" ( default ).

//---- Note : Play voice TTS if Text_To_Speech_Alerts is "true" ( default ).

void Alerts()
 {
  if (!Time[0]>alert_time)return;
 
   if (value[1]>value2[1] && value[2]<value2[2]) 
    { 
     if (PopUp_Alerts)Alert(Symbol(), PeriodToStr(), "- i_Trend Cross -> UP !"); 
     if (Text_To_Speech_Alerts) gSpeak ( CurrentPeriod + "," + CurrentPair + " UP, " );
     if (Email_Alerts)SendMail("i_Trend Alert", Symbol() + PeriodToStr() + "- i_Trend Cross -> UP !");
     if (Mobile_Push_Alerts)SendNotification(Symbol() + PeriodToStr() + "- i_Trend Cross -> UP !");
     alert_time=Time[0];
    }
   if (value2[1]>value[1] && value2[2]<value[2]) 
    { 
     if (PopUp_Alerts)Alert(Symbol(), PeriodToStr(), "- i_Trend Cross -> DOWN !"); 
     if (Text_To_Speech_Alerts) gSpeak ( CurrentPeriod + "," + CurrentPair + "DOWN, " );
     if (Email_Alerts)SendMail("i_Trend Alert", Symbol() + PeriodToStr() + "- i_Trend Cross -> DOWN !");
     if (Mobile_Push_Alerts)SendNotification(Symbol() + PeriodToStr() + "- i_Trend Cross -> DOWN !");
     alert_time=Time[0];
    }
  
  return; 
 }


void Comments()
 {
  Comment("._.");
  
  return;
 }
 
string PeriodToStr()
 {
  switch(Period())
   {
    case 1:return(" M1 ");
    case 5:return(" M5 ");
    case 15:return(" M15 ");
    case 30:return(" M30 ");
    case 60:return(" H1 ");
    case 240:return(" H4 ");
    case 1440:return(" D1 ");
    case 10080:return(" W1 ");
    case 43200:return(" MN1 ");
    
    default:return(StringConcatenate(" ", Period()," "));
   }
 }
 
 
 //---- EOF